=== debian/control ===
Source: simage
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Steve M. Robbins <smr@debian.org>,
 Anton Gladky <gladk@debian.org>
Vcs-Git: git://anonscm.debian.org/debian-science/packages/simage.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/simage.git
Homepage: https://bitbucket.org/Coin3D/simage
Section: graphics
Priority: optional
Build-Depends:
 autotools-dev,
 debhelper (>= 9),
 libgif-dev,
 libjpeg-dev,
 libpng-dev,
 libsndfile1-dev,
 libtiff-dev,
 libvorbis-dev,
 zlib1g-dev
Standards-Version: 3.9.4

Package: libsimage-dev
Architecture: any
Section: libdevel
Multi-Arch: foreign
Depends:
 libgif-dev,
 libjpeg-dev,
 libpng-dev,
 libsimage20 (= ${binary:Version}),
 libsndfile1-dev,
 libtiff-dev,
 libvorbis-dev,
 pkg-config,
 zlib1g-dev,
 ${misc:Depends}
Description: generic interface to various image file format libraries. Development files.
 The simage library provides a simplified and uniform interface to many
 image file format libraries, and it includes internal support for some
 image file formats too. The package ships development files.

Package: libsimage20
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: same
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: generic interface to various image file format libraries
 The simage library provides a simplified and uniform interface to many
 image file format libraries, and it includes internal support for some
 image file formats too.
