=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autotools_dev

extra_flags = \
   --enable-static \
	 --with-targa \
	 --with-rgb \
	 --with-pic \
	 --with-xwd \
	 --with-eps \
	 --without-mpeg2enc

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
