## simage 1.8.0

=== debian/changelog ===
simage (1.8.0-2build1) lunar; urgency=medium

  * Rebuild against latest tiff

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sat, 04 Feb 2023 07:34:25 -0500

simage (1.8.0-2) unstable; urgency=medium

  [ Steve Robbins ]
  * New patch 0002-Change-non-error-output-to-stdout-instead-of-stderr.
    Change example code used in debian/tests to print non-error output
    to stdout rather than stderr.  Needed because output on stderr
    is considered a test failure.

 -- Steve M. Robbins <smr@debian.org>  Mon, 10 Feb 2020 20:55:18 -0600

simage (1.8.0-1) unstable; urgency=medium

  [ Steve Robbins ]
  * New upstream version 1.8.0
  * Update to debhlper 12.  Switch to cmake build system.
  * Refresh patches for 1.8.0.  New patch to fix CMake configuration.
  * Update files installed for libsimage-dev: no binary, no manpage, no Coin integration file.

 -- Steve M. Robbins <smr@debian.org>  Sun, 26 Jan 2020 14:13:58 -0600

simage (1.7.1~2c958a6.dfsg-5) unstable; urgency=medium

  * Team upload.
  * [fdb52c1] Remove Testsuite-field in d/control
  * [c414858] Update VCS-fields to salsa
  * [7692dc1] Set Standards-Version to 4.1.4
  * [75c428f] Remove myself from uploaders
  * [b8c3acb] Remove multi-atch: foreign from d/control

 -- Anton Gladky <gladk@debian.org>  Tue, 22 May 2018 21:13:39 +0200

simage (1.7.1~2c958a6.dfsg-4) unstable; urgency=medium

  * [d223a78] Replace stderr by stdout in example.

 -- Anton Gladky <gladk@debian.org>  Tue, 06 Sep 2016 19:59:40 +0200

simage (1.7.1~2c958a6.dfsg-3) unstable; urgency=medium

  * [cd13cae] Apply cme fix dpkg.
  * [7aee1b8] Add autopkgtest.
  * [2132d39] Add include-binaries for the test image.

 -- Anton Gladky <gladk@debian.org>  Sun, 04 Sep 2016 19:23:07 +0200
