=== debian/changelog ===
simage (1.8.3+ds-2) unstable; urgency=medium

  [ Steve Robbins ]
  * [6873332] Drop use of embedded quantize code in favour of using giflib
    version.  The gifbib prototype has added const qualifiers that make the
    function delcarations incompatible.  Closes: #1065721.

 -- Steve M. Robbins <smr@debian.org>  Sat, 09 Mar 2024 17:39:45 -0600

simage (1.8.3+ds-1) unstable; urgency=medium

  [ Steve Robbins ]
  * [abae010] Add watch file.
  * [a232d5f] Upstream source: set to github.  Add files-excluded.
    Fix copyright short name.
  * [5ffbb4e] New upstream version 1.8.3+ds
  * [0a796d0] Don't add C flags to pkgconfig file.

 -- Steve M. Robbins <smr@debian.org>  Sun, 02 Jul 2023 14:16:30 -0500
