=== debian/control ===
Source: simage
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Section: graphics
Priority: optional
Build-Depends: cmake,
               debhelper (>= 12),
               libgif-dev,
               libjpeg-dev,
               libpng-dev,
               libsndfile1-dev,
               libtiff-dev,
               libvorbis-dev,
               zlib1g-dev
Standards-Version: 4.1.4
Vcs-Browser: https://salsa.debian.org/science-team/simage
Vcs-Git: https://salsa.debian.org/science-team/simage.git
Homepage: https://bitbucket.org/Coin3D/simage

Package: libsimage-dev
Architecture: any
Section: libdevel
Depends: libgif-dev,
         libjpeg-dev,
         libpng-dev,
         libsimage20 (= ${binary:Version}),
         libsndfile1-dev,
         libtiff-dev,
         libvorbis-dev,
         pkg-config,
         zlib1g-dev,
         ${misc:Depends}
Description: generic interface to various image file format libraries. Development files.
 The simage library provides a simplified and uniform interface to many
 image file format libraries, and it includes internal support for some
 image file formats too. The package ships development files.

Package: libsimage20
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: generic interface to various image file format libraries
 The simage library provides a simplified and uniform interface to many
 image file format libraries, and it includes internal support for some
 image file formats too.
