## simage 1.8.4%2Bds

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: simage
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Steve M. Robbins <smr@debian.org>
 Section: graphics
 Priority: optional
 Build-Depends: cmake,
-               debhelper (>= 12),
+               debhelper-compat (= 13),
                libgif-dev,
                libjpeg-dev,
                libpng-dev,
@@ -12,10 +12,10 @@
                libtiff-dev,
                libvorbis-dev,
                zlib1g-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/science-team/simage
 Vcs-Git: https://salsa.debian.org/science-team/simage.git
-Homepage: https://bitbucket.org/Coin3D/simage
+Homepage: https://www.coin3d.org/simage/html/
 
 Package: libsimage-dev
 Architecture: any
@@ -27,7 +27,7 @@
          libsndfile1-dev,
          libtiff-dev,
          libvorbis-dev,
-         pkg-config,
+         pkgconf,
          zlib1g-dev,
          ${misc:Depends}
 Description: generic interface to various image file format libraries. Development files.
