## simage 1.8.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,8 @@
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.0...3.29)
 
 set(SIMAGE_MAJOR_VERSION 1)
 set(SIMAGE_MINOR_VERSION 8)
-set(SIMAGE_MICRO_VERSION 3)
+set(SIMAGE_MICRO_VERSION 4)
 set(SIMAGE_BETA_VERSION)
 set(SIMAGE_VERSION ${SIMAGE_MAJOR_VERSION}.${SIMAGE_MINOR_VERSION}.${SIMAGE_MICRO_VERSION}${SIMAGE_BETA_VERSION})
 
@@ -58,6 +58,7 @@
 option(SIMAGE_BUILD_EXAMPLES "Build examples" ON)
 option(SIMAGE_BUILD_TESTS "Build tests" ON)
 option(SIMAGE_BUILD_DOCUMENTATION "Build and install API documentation (requires Doxygen)." OFF)
+option(SIMAGE_BUILD_AWESOME_DOCUMENTATION "Build and install API documentation in new modern style (requires Doxygen)." OFF)
 cmake_dependent_option(SIMAGE_USE_AVIENC "Use Video for Windows for AVI encoding" ON "WIN32" OFF)
 cmake_dependent_option(SIMAGE_USE_GDIPLUS "Use GDI+ on Windows to load/save images" ON "WIN32" OFF)
 cmake_dependent_option(SIMAGE_USE_CGIMAGE "Use CGImage on OS X to load/save images" ON "APPLE" OFF)
@@ -191,6 +192,7 @@
 report_prepare(
   SIMAGE_BUILD_SHARED_LIBS
   SIMAGE_BUILD_DOCUMENTATION
+  SIMAGE_BUILD_AWESOME_DOCUMENTATION
   SIMAGE_USE_QIMAGE
   SIMAGE_USE_QT5
   SIMAGE_LIBJASPER_SUPPORT
@@ -282,11 +284,3 @@
   endif()
 endif()
 
-if(SIMAGE_OGGVORBIS_SUPPORT)
-  find_package(Ogg REQUIRED)
-  find_package(Vorbis REQUIRED)
-  if(OGG_FOUND)
-    find_package(Opus)
-  endif()
-endif()
-
