=== debian/changelog ===
simage (1.8.4+ds-1) unstable; urgency=medium

  [ Steve M. Robbins ]
  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Fix Maintainer name of Debian Science team (routine-update)
  * Replace transitional package pkg-config by pkgconf in Build-Depends
    (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * [315f9bc] Install cmake files.
  * [52ca665] install simage-config
  * [2b8f2ec] install simage-default.cfg

 -- Steve M. Robbins <smr@debian.org>  Thu, 14 Aug 2025 22:33:54 -0500
