=== debian/tests/control ===
Tests: check1 check2
Depends: libsimage-dev, build-essential
