=== debian/watch ===
version=4
opts=dversionmangle=s/[+~]ds\d*$//,repacksuffix=+ds \
   https://github.com/coin3d/simage/tags .*\/v(\d\S+)\.tar\.gz
